<template>
  <div class="account-price">
    <HeaderPrice/>
    <div class="account-price__content">
      <div
          class="account-price__content-bid"
          :class="hasColor"
      >
        {{ order.totalPriceAmount && (order.totalPriceAmount.priceWithVat / 100) | currency }} <span>₽</span>
        <i class="icon question"/>
      </div>

      <div class="account-price__content-tax">
        <i
          v-if="isInternational"
          class="icon world international-icon"
          title="Международные перевозки, НДС 0%"
        />
        <span>{{ hasVat }}</span>
      </div>

      <div
          v-if="order.extraCost.extraDistanceCost || order.extraCost.extraPointsCost"
          class="account-price__additional-run"
      >
        <p class="account-price__additional-run-bid">Дополнительно к базовой ставке</p>

        <div
            v-if="order.extraCost.extraDistanceCost"
            class="account-price__additional-run-info"
        >
          <span class="point">Допробег: </span>
          <span class="price">{{ order.extraCost.extraDistanceCost.priceWithVat / 100 | currency }} ₽ </span>
          <span class="vat">(НДС {{ order.extraCost.extraDistanceCost.vatPrice / 100 | currency }} ₽)</span>
        </div>
        <div
            v-if="order.extraCost.extraPointsCost"
            class="account-price__additional-run-info"
        >
          <span class="point">Допточки: </span>
          <span class="price">{{ order.extraCost.extraPointsCost.priceWithVat / 100 | currency }} ₽ </span>
          <span class="vat">(НДС {{ order.extraCost.extraPointsCost.vatPrice / 100 | currency }} ₽)</span>
        </div>
      </div>
      <component :is="isType"/>
    </div>
    <Indicators :indicators="order"/>
  </div>
</template>
<script>
  import ObTooltip from 'common-components/src/obComponents/obTooltip'
  import HeaderPrice from './headerPrice'
  import IsAuction from './auction/index'
  import IsBooking from './booking/index'
  import controls from '../../components/controls'
  import Indicators from './indicators'
  import { mapGetters } from 'vuex'
  import STEPS from '@/constants/steps.js'
  import transformer from '../../../../transformer'
  import { formatNumber } from 'common-components/src/helpers/common'

  export default {
    mixins: [transformer],
    components: {
      HeaderPrice,
      IsAuction,
      IsBooking,
      controls,
      Indicators,
      ObTooltip
    },
    data() {
      return {
        STEP: STEPS
      }
    },
    computed: {
      ...mapGetters({
        order: 'account/order',
        vat: 'account/vat',
        isVatPayer: 'account/isVatPayer'
      }),
      isAuction () {
        return this.order.type === this.STEP.AUCTION
      },
      isType() {
        if (this.isAuction) {
          return IsAuction
        } else {
          return IsBooking
        }
      },
      hasColor() {
        let isClass = '';
        if (this.order.type === this.STEP.AUCTION && this.order.status === this.STEP.ACTIVE) {
          if (this.order.currentState === this.STEP.LOSING) {
            isClass = 'warning'
          } else if (this.order.currentState === this.STEP.WIN) {
            isClass = 'success'
          } else if (this.order.currentState === this.STEP.NO_BIDS) {
            isClass = 'await'
          }
        } else if (this.order.type === this.STEP.BOOKING && this.order.status === this.STEP.LOSER) {
          isClass = 'warning'
        }
          else if(this.order.status === this.STEP.LOSER) {
            isClass = 'loser'
        }
        return isClass;
      },
      routeCategory () {
        return this.order.suborderSpecies?.routeCategory
      },
      isInternational () {
        return this.routeCategory === 'INTERNATIONAL'
      },
      hasVat() {
        if (!this.isVatPayer) {
          return this.isAuction ? 'Эта ставка не облагается НДС' : 'Не облагается НДС';
        } else {
          return `НДС ${formatNumber(this.order.totalPriceAmount?.vatValue / 100)} ₽`;
        }
      }
    }
  }
</script>
<style lang="scss" scoped>
  @import "~common-components/src/static/css/variables";

  .account-price {
    display: flex;
    flex-direction: column;
    justify-content: space-between;
    padding: 20px 20px 16px;

    .warning {
      color: $color-error;
    }
    .loser {
      color: $color-error;
      text-decoration: line-through;
    }
    .success {
      color: $green-craiola;
    }

    .await {
      color: $gray-slate;
    }

    &__content {
      display: flex;
      flex-direction: column;
      align-items: center;
      width: 100%;
      padding: 20px 10px 0 10px;

      &-bid {
        position: relative;
        display: flex;
        justify-content: center;
        align-items: center;
        font-weight: bold;
        font-size: 24px;
        line-height: 36px;
        letter-spacing: 0.2px;
        color: $color-text-base;
        mix-blend-mode: normal;
        opacity: 0.9;

        & span {
          margin-left: 10px;
        }

        & .question {
          position: absolute;
          font-size: 12px;
          color: $gray-slate;
          right: -20px;
        }
      }

      &-tax {
        display: flex;
        align-items: center;
        font-size: 10px;
        line-height: 12px;
        letter-spacing: 0.4px;
        color: $gray-slate;
      }

      .international-icon {
        margin-right: 7px;
        font-size: 14px;
        line-height: 14px;
        color: $color-blue-navy-blue;
      }

      &-links {
        margin-top: 16px;
        font-style: normal;
        font-weight: normal;
        font-size: 14px;
        line-height: 18px;
        letter-spacing: 0.4px;
        color: $color-blue-navy-blue;

        a {
          cursor: pointer;
        }
      }
    }
    &__additional-run {
      margin: 20px 0;
      color: $gray-slate;
      text-align: center;
      &-bid {
        font-size: 10px;
        line-height: 12px;
        letter-spacing: 0.4px;
        margin-bottom: 5px;
      }
      &-info {
        margin-bottom: 5px;
        .point {
          font-size: 14px;
          line-height: 18px;
          letter-spacing: 0.2px;
        }
        .price {
          font-size: 14px;
          line-height: 18px;
          letter-spacing: 0.2px;
          color: $Grey-900;
        }
        .vat {
          font-size: 10px;
          line-height: 12px;
          letter-spacing: 0.4px;
          color: #737682;
        }
      }
    }
  }
</style>

<style lang="scss">
.account-price-detail-popper {
  .price-detail-row + .price-detail-row {
    margin-top: 3px;
  }
  .price-detail-row {
    width: 185px;
    display: flex;
    align-items: center;
    justify-content: space-between;
    span {
      & + span {

      }
    }
  }
}
</style>
